=== modified file 'bzrlib/tests/test_inv.py'
--- bzrlib/tests/test_inv.py	2006-02-11 11:58:06 +0000
+++ bzrlib/tests/test_inv.py	2006-02-17 14:55:36 +0000
@@ -479,3 +479,14 @@
 
         self.failUnless(t2.is_executable(a_id), "'a' lost the execute bit")
         self.failIf(t2.is_executable(b_id), "'b' gained an execute bit")
+
+class TestRevert(TestCaseWithTransport):
+    def test_dangling_id(self):
+        wt = self.make_branch_and_tree('b1')
+        self.assertEqual(len(wt.inventory), 1)
+        open('b1/a', 'wb').write('a test\n')
+        wt.add('a')
+        self.assertEqual(len(wt.inventory), 2)
+        os.unlink('b1/a')
+        wt.revert([])
+        self.assertEqual(len(wt.inventory), 1)

=== modified file 'bzrlib/transform.py'
--- bzrlib/transform.py	2006-02-17 06:14:04 +0000
+++ bzrlib/transform.py	2006-02-17 14:55:36 +0000
@@ -989,7 +989,7 @@
             else:
                 change_entry(tt, file_id, working_tree, target_tree, 
                              get_trans_id, backups, trans_id)
-        for file_id in working_tree:
+        for file_id in working_tree.inventory:
             if not interesting(file_id):
                 continue
             if file_id not in target_tree:

